#!/bin/sh
#
# Licensed Materials - Property of IBM
# 
# (C) Copyright IBM Corp. 2000,2007. All Rights Reserved.
# 
# US Government Users Restricted Rights - Use, duplication or
# disclosure restricted by GSA ADP Schedule Contract with
# IBM Corp.
#
AWK=awk

# Define values from the header file
LPM_NIS_SECS=0
LPM_NIS_DAYS=1
LPM_NIS_WEEK=7
LPM_NIS_MAPNAME=passwdchg
x86_linux_2_gran=${LPM_NIS_DAYS}
s390_linux_2_gran=${LPM_NIS_DAYS}
ppc_linux_2_gran=${LPM_NIS_DAYS}
sparc_solaris_2_gran=${LPM_NIS_DAYS}
rios_aix_4_gran=${LPM_NIS_SECS}
hp9000_ux_10_gran=${LPM_NIS_WEEK}
LPM_EXT_LIBBASE=/usr/lib/liblpmext
LIBNAME_SUFF=.so
#
# Uncomment the following line to get debugging info
#
#debug LEVELS
#debug=1

#
# Grab the platform type
#
PLATFORM=`uname`
if [ $debug ]; then
    echo "Platform is $PLATFORM."
fi

#
# Set the NIS directory, depending on the platform
#
YPDIR=/var/yp
DOMAIN=`domainname`

#
# process the makefile using nawk, add directive to generate
# the map of password change dates.
#
if [ $debug ]; then
    echo "Make a copy of ${YPDIR}/Makefile."
fi
cp ${YPDIR}/Makefile ${YPDIR}/Makefile.bak.pdos.ucfg
${AWK} 'BEGIN { deball=1000; deblil=100; };
{
    mapname_time=mapname ".time";
    mapname_byname=mapname ".byname";

    if ($1 ~ /^all:/) {
        # This clause is to remove the dependency for the PDOS map
	# to the list that is built by "all:"
        do {
            if ($0 ~ mapname) {
		mapname_space=" " mapname;
                gsub(mapname_space,"",$0);
            }
            print $0
            getline;
        } while (! ($0 ~ /^[a-zA-Z0-9]/)) 
	print $0
    } else if ($1 ~ mapname_time) {
        while (! ($0 ~ /^$/)) {
            getline;
        }
    } else if ($1 ~ mapname_byname) {
        while (! ($0 ~ /^$/)) {
            getline;
        }
    } else if ($1 ~ mapname) {
        printf("");
    } else {
        print $0
    }
}' "deb=$debug" "deblil=$debug_lil" "mapname=${LPM_NIS_MAPNAME}" \
	${YPDIR}/Makefile > ${YPDIR}/Makefile.new

mv ${YPDIR}/Makefile.new ${YPDIR}/Makefile

#
# Have to remove the maps that were built.
#
if [ -f ${YPDIR}/${LPM_NIS_MAPNAME}* ]; then 
    rm ${YPDIR}/${LPM_NIS_MAPNAME}* 
fi
if [ -f ${YPDIR}/${DOMAIN}/${LPM_NIS_MAPNAME}* ]; then
    rm ${YPDIR}/${DOMAIN}/${LPM_NIS_MAPNAME}*
fi
